﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;

namespace TileViewRestoredItemsPosition
{
	public partial class MainPage : UserControl
	{
		private Dictionary<RadTileViewItem, int> originalPositions = new Dictionary<RadTileViewItem, int>();
		private ObservableCollection<RadTileViewItem> items = new ObservableCollection<RadTileViewItem>();
		public MainPage()
		{
			InitializeComponent();

			RadTileViewItem item1 = new RadTileViewItem() { Header = "111", Position = 0 };
			RadTileViewItem item2 = new RadTileViewItem() { Header = "222", Position = 1 };
			RadTileViewItem item3 = new RadTileViewItem() { Header = "333", Position = 2 };
			RadTileViewItem item4 = new RadTileViewItem() { Header = "444", Position = 3 };
			items.Add(item1);
			items.Add(item2);
			items.Add(item3);
			items.Add(item4);

			this.myTileView.ItemsSource = items;

			foreach (var item in items)
			{
				originalPositions.Add(item, item.Position);
			}
		}

		private void myTileView_TilesStateChanged(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			foreach (RadTileViewItem item in this.myTileView.Items)
			{
				if (item.TileState == TileViewItemState.Restored)
				{
					item.Position = originalPositions[item];
				}
			}
		}

		private void myTileView_TilePositionChanged(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			var item = e.OriginalSource as RadTileViewItem;
			if (item.TileState == TileViewItemState.Restored && originalPositions[item] != 0)
			{
				originalPositions[item] = item.Position;
			}
		}
	}
}
